.include "entity.h.s"
.include "game.h.s"
.include "template.h.s"
.include "animation.h.s"
.include "score.h.s"

.include "../systems/physics.h.s"
.include "../systems/render.h.s"
.globl cpct_akp_SFXPlay_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSprite_asm


defaultEntity::
    .db 01    ;;;; X
    .db 01    ;;;; Y                           
    .db 01    ;;;; wi
    .db 01    ;;;; he
    .db 01    ;;;; vX
    .db 01    ;;;; vy
    .db 01 ;;;; tipo de entidad
    .db 0 ;;;; tipo de entidad
    .db 01  ;; componentes de entidad
    .db 01 ;; colisiona contra
    .dw 0x0000 ;;; comportamiento ia
    .db 01    ;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 01   ;;;; X destino
    .db 01  ;;;; Y destino    
    .db 01 ;; contador disparo
    .dw 0x0000 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 01 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1 ;vida
    .db 1 ;daño o cooldwon de recibir daño en caso de ser el jugador
    .db 0 ; tiempo que tarda en autodestruirse si se autodestruye
    .db 0 ;puntos
sizeEntity=.-defaultEntity
_sizeArray = maxEntities*sizeEntity
_nextEntity:: .dw _arrayEntities
_reservedEntities:: .db 0

_arrayEntities:: .ds _sizeArray




;; Creamos una entidad
;; INPUT:
;; HL- direccion de la plantilla de la entidad a crear
;; registros destruidos: HL, DE, AF, BC
createEntity::
    ld a, (_reservedEntities)
    ld b, a
    ld a, #maxEntities
    sub b
    jr z, not_create_entity
    ;;if(maxEntidades != _reservedEntities)
        ;; copia los primeros BC valores de HL en DE
        ld de, (_nextEntity)
        ld bc, #sizeEntity
        ldir      ;;va reduciendo la BC en cada copia, perdemos el valor
        ;;sumo 1 al contador de estrellas
        ld a, (_reservedEntities)
        inc a
        ld (_reservedEntities), a

        ;; desplazamos el puntero de _ultimaEntidad
        ld hl, (_nextEntity)
        ld bc, #sizeEntity
        add hl, bc
        ld (_nextEntity), hl
   not_create_entity:
ret

;;; recibe en HL la plantilla de entidad
;;; redibe en B la x y en C la y
createEntityInPlace::
    push bc
    call createEntity ;;devuelve hl en la posicion de la siguiente entidad a la recien creada
    pop bc
    ld de,#sizeEntity
    or a 
    sbc hl,de ;;volvemos a la posicion inicial de la entidad recien creada
    ld a,b
    ld (hl),a
    inc hl
    ld a,c
    ld (hl),a
    dec hl
ret


signature:: .db 0
function_call:: .dw 0x0000
counter:: .db 0

;; pasar en DE la direccion de la funcion  pasar en no se... a la signature de 
;; los tipos  00000001  o 00000011 si es de varios tipos por ejemplo

doBySignature::  
    ld (signature),a
    ld (function_call),de
    ld ix,#_arrayEntities

    ld a,(_reservedEntities)
    ld (counter),a
    sub #0
    jr z,endSignature
    forSignature:
      
        ld a,(signature)    ;;colocamos la signature en a 
        and e_component(ix) ;; hacemos un and con el componente para ver si coinciden
        ld hl,(signature)  ;;Restamos la signature al resultado para verificar  
        sub l                 ;; 1-1= 0 else para fuera
        jr nz,nextBySignature

        ld a,e_type(ix)         ;; a es igual al tipo
        add a,#typeInvalid    ;; si a+0 es 0 es que es invalida 
        jr z,endSignature    ;;si no es 0 llamamos al bucle fisico con   

            or a
            ld hl,#nextBySignature
            push hl
            ld hl,(function_call)
            jp (hl)
         
          nextBySignature:
            ld bc,#sizeEntity
            add ix,bc         ;;aumentamos el indice para ir a la next
            ld a,(counter)
            dec a
            ld (counter),a
            jr nz,forSignature

  endSignature:

ret

counterRight:: .db 0
doBySignaturePairs::        ;; pasar en DE la direccion de la funcion  pasar en no se... a la signature de los tipos  00000001  o 00000011 si es de varios tipos por ejemplo
    
    ld (signature),a
    ld (function_call),de
    ld ix,#_arrayEntities

    ld a,(_reservedEntities)
    ld (counter),a
    sub #0
    jr z,endPairs

      mainPairLoop:
        ;;iniciamos el segundo contador a 0 (el de la derecha)
        ld a, #0
        ld (counterRight), a
        ld a,(signature)     ;pasamos la signature a A en A tenemos una signature, tenemos que compararla con la de la entidad con un and y luego a el resultado restarle la signature y si da 0 son iguales

        and e_component(ix)               ;hacemos un and con la signature (en A) y el tipo de la entidad (en (HL))  000000001 and 000000001
                              ;;ahora en a tenemos el resultado del and y hay que igualarlo a la signature
        ld hl,(signature)         ;; 0000 00001
        sub l                 ;; 1-1= 0 else para fuera
        jr nz,nextLeft
          ld a,e_type(ix)             ;; a es igual al tipo

          add a,#typeInvalid       ;; si a +0 es 0 es que es invalida
          jr z,endPairs                   ;;si no es 0 llamamos al bucle fisico con   

            ;;ENTIDAD DE LA IZQUIERDA YA SE COMPRUEBA QUE ES VALIDA Y TIENE COMPONENTE COLISIONABLE
            push ix
            pop iy
            ld de, #sizeEntity
            add iy, de

            secondLoopStart:
              ;;ahora nos encontramos en la entidad de la derecha
              ld a,(signature)           ;signature a A                  
              and e_component(iy)                                  
              ld hl,(signature)    ;; comprobamos si la firma coincide con el componente     
              sub l  
              jr nz,nextRight

                ld a,e_type(iy)             ;; a es igual al tipo
                add a,#typeInvalid       ;; si a +0 es 0 es que es invalida 
                jr z,nextLeft

                 or a
                 ld hl,#nextRight
                 push hl
                 ld hl,(function_call)
                 jp (hl)

                nextRight:
                  ld bc,#sizeEntity
                  add iy,bc
                  ld a,(counterRight)
                  inc a
                  ld (counterRight),a
                  ld b, a
                  ld a, (counter)
                  sub a, b
                  jr z, nextLeft
                    jr secondLoopStart ;en el caso de que no hemos acabado de ver todas las entidades, iteramos segundo bucle

         
        nextLeft:
          ld bc,#sizeEntity
          add ix,bc
          ld a,(counter)
          dec a
          ld (counter),a

          jr nz,mainPairLoop

  endPairs:

ret


setShot::
  ld ix, #_arrayEntities  ;jugador

  ld hl, (_nextEntity)
  ld bc, #sizeEntity
  sbc hl, bc

  push hl
  pop iy    ;disparo recien creado

  ;;posicion
  ld a, e_x(ix)
  add #3
  ld e_x(iy), a

  ld a, e_y(ix)
  add #8
  ;sbc #4
  ld e_y(iy), a

  ;;velocidad
  ld a, (dirPlayerX)
  ld e_vx(iy), a

  ld a, (dirPlayerY)
  ld e_vy(iy), a

ret


checkHeart::
  ld de, #0xC000
  ld c, #2
  ld b, #5
  call cpct_getScreenPtr_asm

  ex de, hl
  push de
  ld c, #6
  ld b, #14

  or a

  ld a, e_HP(ix)
  ld e, #0x10
  sub e
  jr c, heart4

      or a
      ld a, e_HP(ix)
      ld e, #0x20
      sub e
      jr c, heart3

        or a
        ld a, e_HP(ix)
        ld e, #0x30
        sub e
        jr c, heart2

          or a
          ld a, e_HP(ix)
          ld e, #0x40
          sub e
          jr c, heart1

    heart0:
      ld hl, #_heart_0  
      jr pintar 

    heart4:
      ld hl, #_heart_4
      jr pintar 

    heart3:
      ld hl, #_heart_3
      jr pintar 
      
    heart2:
      ld hl, #_heart_2
      jr pintar 

    heart1:
      ld hl, #_heart_1


    pintar:
      pop de
      call cpct_drawSprite_asm
      

ret

;;En B hay que pasar el daño que va a sufrir el personaje (en positivo)
damagePlayer::
  ld a, e_dmg(ix)
  cp #0
  jr nz, endDamagePlayer


    ;;reseteamos cooldown
    ld a, #cooldownDamagePlayer
    ld e_dmg(ix),a

    ld a, e_component(ix)
    or #cmpAnim           ;; anadir componente
    ld e_component(ix), a

    ld e_animPointer2(ix), #<animDamage
    ld e_animPointer1(ix), #>animDamage
    ld e_animCounter(ix), #0x03

    push ix

    ld ix, #animDamage
    ld hl, (spriteActual)

    ld 1(ix), l
    ld 2(ix), h


    pop ix

    ;;restamos vida
    ld a, e_HP(ix)
    sub b
    jp nc, notDeath
      ;;ha muerto, ponemos su vida a 0
      ld a, #0
      ld e_HP(ix),a

      ret

  notDeath:
  ;;actualizamos vida
  daa
  ld e_HP(ix),a
  call checkHeart

  call showLooseHP  

    ;sonido recibir daño
    ld l,#4
    ld h,#15
    ld e,#25
    ld d,#3
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm

    
  endDamagePlayer:
ret

healPlayer::
  push ix
  push hl
  pop ix
  call markEntity
  pop ix



  ld a, e_HP(ix)            ;;en la vida del personaje tenemos un numero en decimal
  add #5                    ;;le sumamos un numero y automaticamente se vuelve hexadecimal
  daa
  sub #maxHealthPlayer                 ;;le tengo que restar 99 ya en hexadecimal, 
  jp m, healthNotFUll       ;;lo resta la hacemos para volver a un valor decimal siempre que no exceda en 9 el botiqin sino se lia ya que 10=A y no conseguiriamos al restar un numero en decimal
    
    ld b,#0
    ld c, a
    call addScore 
    ld a, #maxHealthPlayer
    ld e_HP(ix), a
    call showGainHP

    ld l,#2
    ld h,#15
    ld e,#45
    ld d,#1
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
    ret

  healthNotFUll:

  ld a, e_HP(ix)
  add #5
  daa
  ld e_HP(ix), a

  call checkHeart

  call showGainHP

   ld l,#2
    ld h,#15
    ld e,#45
    ld d,#1
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm
ret


getTreasure::

  push ix
  push hl
  pop ix
  call markEntity
  pop ix
  ld bc,#0x0020
  call addScore
  
ret

;; pasamos en HL la bala y en DE el enemigo
shotHit::
  push hl       ; aqui tenemos la bala      
  pop ix

  call markShot

  push de   ;;metemos al enemigo a iy
  pop iy
  ld a,e_HP(iy)
  dec a
  jr nz,noDestruir
  ld b,#0
  ld a,e_points(iy)
  ld c,a
 ; ld bc, #0x0005
  call addScore
  push iy
  pop ix
  ld a,#cmpAnim
  or #cmpRender
  ld e_component(ix),a
  ld e_wi(ix), #7
  ld e_he(ix), #14
  ld e_sprite2(ix),#<_explosion_0
  ld e_sprite1(ix),#>_explosion_0
  ld e_animPointer2(ix),#<animExplosion
  ld e_animPointer1(ix),#>animExplosion
  ld e_animCounter(ix),#0x02 

     
  ld l,#1
  ld h,#15
  ld e,#35
  ld d,#1
  ld bc,#0
  ld a,#4
  call cpct_akp_SFXPlay_asm
  ret
  noDestruir:
  ld e_HP(iy),a

  ;; knockback    ix - bala, iy - jugador
  ld a, e_vx(ix)
  add #0
  jr z, checkVelY

    ld b, #velocityShotX
    add a, b
    jr z, negativeX

    ;; velocidad positiva (hacia derecha)
      ld a, e_x(iy)
      ld b, #3
      add a, b

      push af

      ld e, a       ;; nueva posicion en E

      ld a, #rightBorder
      sub #paddingH       ;; limite abajo
      ld b, a     ;; limite abajo en B

      pop af
      add a, e_wi(iy)

      cp b
      jr nc, checkVelY
      jr z, checkVelY

        ld e_x(iy), e

      jr checkVelY


  negativeX:      ;; hacia izquierda
    ld a, e_x(iy)
    ld b, #3
    sub b
    ld e, a       ;; nueva posicion en E

    ld b, #paddingH

    cp b
    jr c, checkVelY
    jr z, checkVelY

      ld e_x(iy), e


  checkVelY:
    ld a, e_vy(ix)    ; bala
    add #0
    ret z

      ld b, #velocityShotY
      add a, b
      jr z, negativeY

      ;; hacia abajo
        ld a, e_y(iy)
        ld b, #6
        add a, b      ;; nueva posicion en A

        push af

        ld e, a       ;; nueva posicion en E

        ld a, #bottomBorder
        sub #paddingBottom       ;; limite abajo
        ld b, a     ;; limite abajo en B

        pop af
        add a, e_he(iy)

        cp b
        ret nc
        ret z

          ld e_y(iy), e

        ret

    negativeY:      ;; hacia arriba
      ld a, e_y(iy)
      ld b, #6
      sub b
      ld e, a       ;; nueva posicion en E

      ld b, #paddingTop

      cp b
      ret c
      ret z

        ld e_y(iy), e


ret


markEntity::
  ld a,#typeDead
  or e_type(ix)
  ld e_type(ix),a 
  or a
ret


markShot::
      ld a,e_subType(ix)
      sub #0
      jr nz,enemyShoot
        ld a, (contShot)
        dec a
        ld (contShot),a
        jr allyShoot
        enemyShoot:
          ld a, (contEnemyShot)
          dec a
          ld (contEnemyShot),a
        allyShoot:
        call markEntity

ret

lastX: .db 0
lastY: .db 0
dropsItem: .db 0
destroyEntity::
  ld a,e_x(ix)
  ld (lastX),a
  ld a,e_y(ix)
  ld (lastY),a

  ld a,e_subType(ix)
  and #dropTreasure
  cp #dropTreasure
  jr nz, noDropTreasure

  ld (dropsItem),a
  jr  endDrop
  noDropTreasure:

  ld a,e_subType(ix)
  and #dropHealing
  cp #dropHealing

  ld (dropsItem),a

   endDrop:


  ld bc,#sizeEntity          ;;  t= 5
  ld hl,(_nextEntity)       ;;cogemos la ultima entidad
  or a
  sbc hl,bc                     ;;vamos al inicio de esta
  ld (_nextEntity),hl

  push ix   ;;metemos la direccion de la entidad a destruir en DE
  pop de

  or a
  sbc hl,de     ;;si da 0 es que la entidad es la ultima del array
  jr z,esUltima

    ld hl,(_nextEntity)
    ;; copiamos la ultima entidad valida del array en la entidad a matar
    ldir      
  esUltima:

  ;ld e_type(ix),#typeInvalid
   ld de,#e_type
  ld hl,(_nextEntity)
  add hl,de
  ld (hl),#typeInvalid

  ld a,(_reservedEntities)
  dec a
  ld (_reservedEntities),a

  ld a,(dropsItem)
  add #0
  ret z
  cp #dropTreasure
  jr z,droppingTreasure
  cp #dropHealing
  jr z,droppingHealing

  droppingTreasure:
  ld hl,#treasure
  jr createDrop
  droppingHealing:
  ld hl,#healing

  createDrop:
  call createEntity
  ld hl,(_nextEntity)
  ld bc,#sizeEntity
  or a
  sbc hl,bc
  ld a,(lastX)
  ld (hl),a
  inc hl
  ld a,(lastY)
  ld (hl),a
  ld a,#0
  ld (dropsItem),a

  ret

updateAliveEntities::
    ld ix,#_arrayEntities
    ld a,(_reservedEntities)
    ld (counter),a
    sub #0
    jr z,fin
    whilee6:
        ld a,e_type(ix)             ;; a es igual al tipo
        add a,#typeInvalid        ;; si a +0 es 0 es que es invalida 
        jr z,fin                   ;;si no es 0 llamamos al bucle fisico con     
         
            ld a,#typeDead
            and e_type(ix)               ;hacemos un and con la signature (en A) y el tipo de la entidad (en (HL))  000000001 and 000000001
                                        ;;ahora en a tenemos el resultado del and y hay que igualarlo a la signature
            ld b,#typeDead         ;; 1000 0001
            sub b                 ;; 1-1= 0 else para fuera
          jr nz, noesta_muerta
            call renderEntity
            call destroyEntity 
          noesta_muerta:
          ld a,#cmpAutoDestruction 
              and e_component(ix) ;; hacemos un and con el componente para ver si coinciden 
              sub #cmpAutoDestruction 
              jr nz,noAutoDes
                ld a,e_destroyCounter(ix)
                add #0
                jr nz,decAuto
                  call markEntity
                  jr noAutoDes
                decAuto:
                  dec a
                  ld e_destroyCounter(ix),a
                  ld b, #0x50         ;;; comprobar si el contador va por un punto en concrto para cambiar la animacion
                  sub b
                  jr nz, noAutoDes

                    ld a, e_component(ix)
                    or #cmpAnim
                    ld e_component(ix), a

                    ld e_animPointer2(ix), #<animTreasure
                    ld e_animPointer1(ix), #>animTreasure
                    ld e_animCounter(ix), #0x07

              noAutoDes: 
                     
            ld bc,#sizeEntity
            add ix,bc
            ld a,(counter)
            dec a
            ld (counter),a
        jr nz,whilee6
  fin:
ret