;simbolos
.globl cpct_scanKeyboard_asm
.globl _cpct_keyboardStatusBuffer

;;Asi es como estan ubicadas las letras en las filas
;row0:: .db 0,0,0,0,0,0,0,0
;row1:: .db 0,0,0,0,0,0,0,0
;row2:: .db 0,0,0,0,0,0,0,0
;row3:: .db 0,0,0,0,p,0,0,0
;row4:: .db 0,m,k,l,i,o,0,0
;row5:: .db 0,n,j,h,y,u,0,0
;row6:: .db v,b,f,g,t,r,0,0
;row7:: .db x,c,d,s,w,e,0,0
;row8:: .db z,0,a,0,q,0,0,0
;row9:: .db 0,0,0,0,0,0,0,0

;;array de punteros a filas
matrix:: .dw row0, row1, row2, row3, row4, row5, row6, row7, row8, row9

;;Ppnemos 0 en todas las posiciones que no queremos detectar con el teclado, asi filtramos las que si queremos siendo estas distintas de 0
;;los valores de las teclas estan en ascii y con las letras en mayusculas, no coinciden con la tabla anterior que son minusculas
row0:: .db 0,0,0,0,0,0,0,0
row1:: .db 0,0,0,0,0,0,0,0
row2:: .db 0,0,0,0,0,0,0,0
row3:: .db 0,0,0,0,80,0,0,0
row4:: .db 0,77,75,76,73,79,0,0
row5:: .db 0,78,74,72,89,85,0,0
row6:: .db 86,66,70,71,84,82,0,0
row7:: .db 88,67,68,83,87,69,0,0
row8:: .db 90,0,65,0,81,0,0,0
row9:: .db 0,0,0,0,0,0,0,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Con la funcion comprobamos que tecla se esta pulsando y en caso de ser una letra valida, la devolvemos
;; Destruye todos los registros
;; Devuelve en "A" el valor en ASCII de la letra
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inputKeyboard::

   startInputKeyboard:
        ;;Escaneamos teclado y nos colocamos en el buffer
        call cpct_scanKeyboard_asm
        ld ix, #_cpct_keyboardStatusBuffer
        ld b, #0

        checkKey:
            ld a, (ix)
            cp #0xFF
            jr nz, pressKey
            ;;no tecla pulsada
                inc ix

                inc b
                ld a,#10 
                sub b
        jr nz, checkKey
        ;; en el caso de no encontrar ninguna tecla pulsada, volvemos al ininio para empezar el proceso otra vez
        jp startInputKeyboard

        ;;Aqui ya se ha pulsado alguna tecla
        ;; en b tenemos la fila
        ;; en a tenemos la columna, habra algo asi 11110111, donde esta el 0 es la tecla pulsada (puede haber mas de un 0)
        pressKey:

        ;;guardamos direccion de la matriz de punteros a fila
        ld hl, #matrix
        ld de, #2
        dec b
        inc b
        jr z, inRow           ;;en este caso es que la tecla pulsada es de la fila 0, entonces nos saltamos el bucle para colocarlos en la fila buena

        ;vamos avanzando hasta llegar a la fila deseada
        positionMatrix:
            add hl, de
            dec b
        jr nz, positionMatrix

        ;;nos encontramos en la fila de la tecla pulsada
        inRow:

        ;;cogemos el puntero de esa fila y lo colocamos en hl
        ld e, (hl)
        inc hl
        ld d, (hl)
        ex de, hl

        cpl ;complemento de "a" para dejar con el valor 1 la tecla pulsada y el resto a 0
        call getAsciiByRow

        ;;en "a" tenemos la letra, lo devuelve la funcion
        cp #0
        jr z, startInputKeyboard
ret


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Con la funcion obtenemos el ascii de la letra pulsada ya indicandonos de que fila es la tecla
;;  INPUT:
;;      -pasar en "hl" la direccion inicial de la fila
;;      -pasar en "a" con todos los bits con valor 1 donde se pulse una tecla
;;
;;Destruye registros: A, BC, E, HL
;;Devuelve en "A" el valor en ASCII de la letra
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
getAsciiByRow::

    ;;guardamos el valor del ascii en "e" para usarlo despues
    ld e, a

    ld c, #8            ;contador
    ld b, #0x80         ;lo usaremos para averiguar que tecla se ha pulsado

    ;con este bucle encontramos la tecla pulsada
    findKey:
        ld a, e
        and b
        jr nz, foundKey
        ;como no es la tecla, pasamos a comprobar la siguiente
        rr b
        inc hl
        dec c
    jr nz, findKey

    foundKey:
    ld a, (hl)
ret