.include "template.h.s"
.include "entity.h.s"
.include "../systems/ai.h.s"
.include "../systems/physics.h.s"
.include "animation.h.s"
.include "patrol.h.s"

player::
    .db 10    ;;;; X
    .db 10   ;;;; Y                  
    .db 7    ;;;; wi                
    .db 16    ;;;; he                 
    .db 0    ;;;; vX               
    .db 0    ;;;; vy
    .db typePlayer ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpInput | cmpCollider ;; componentes de entidad
    .db typeEnemy | typeTreasure | typeHealing;; colisiona contra
    .dw 0x0000 ;;; comportamiento (cmpAi o cmpItem)
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador 
    .dw _spPlayer_00 ;;;; sprite
    .dw animPlayer1 ;; puntero a animacion
    .db #0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db #0x50 ;vida del personaje max 50
    .db 0 ;cooldwon de recibir daño
    .db 0 ;auto destruction
    .db 0 ;puntos

boss::
    .db 51    ;;;; X
    .db 50   ;;;; Y                           
    .db 7    ;;;; wi
    .db 14    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy           ;;quitar esto para que la patrulla vaya bien
    .db typeEnemy ;;;; tipo de entidad
    .db bossSubType ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw bossBehaviour ;;; comportamiento ia
    .db e_ai_state_patrol   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw patrolBoss   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _boss1_0 ;;;; sprite
    .dw  animBoss1 ;; puntero a animacion
    .db 12 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db #0x20
    .db 5 ;daño
    .db 0x20  ;tiempo de espera para el jefe
    .db 0x50 ;puntos

boss2::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 7    ;;;; wi
    .db 14    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy           ;;quitar esto para que la patrulla vaya bien
    .db typeEnemy ;;;; tipo de entidad
    .db bossSubType2 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw bossBehaviour2 ;;; comportamiento ia
    .db e_ai_state_patrol   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw patrolBoss2   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _boss2_0 ;;;; sprite
    .dw  animBoss2 ;; puntero a animacion
    .db 12 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db #0x20
    .db 5 ;daño
    .db 0x20  ;tiempo de espera para el jefe
    .db 0x50 ;puntos

enemy::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 4    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db 0 ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider  ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db e_ai_state_patrol   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw patrol_03   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _zombie_0 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 12 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3
    .db 1 ;daño
    .db 0
    .db 0 ;puntos

zombi::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 6    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db -1    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db dropTreasure | chaser ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw aiChase ;;; comportamiento ia
    .db e_ai_state_chase   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _zombie_0 ;;;; sprite
    .dw animEnemyZombieDer ;; puntero a animacion
    .db #0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3 ;vida
    .db 2 ;daño
    .db 1           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x20 ;puntos

zombiNoPoints::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 6    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db -1    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db chaser ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw aiChase ;;; comportamiento ia
    .db e_ai_state_chase   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _zombie_0 ;;;; sprite
    .dw animEnemyZombieDer ;; puntero a animacion
    .db #0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3 ;vida
    .db 2 ;daño
    .db 1           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x0 ;puntos


zombiHeal::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 6    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db -1    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db dropHealing | chaser ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw aiChase ;;; comportamiento ia
    .db e_ai_state_chase   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _zombie_0 ;;;; sprite
    .dw animEnemyZombieDer ;; puntero a animacion
    .db #0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3 ;vida
    .db 2 ;daño
    .db 1           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x20 ;puntos


patrullero::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 7    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy           ;;quitar esto para que la patrulla vaya bien
    .db typeEnemy ;;;; tipo de entidad
    .db dropTreasure ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db e_ai_state_standBy   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _patrullero_0 ;;;; sprite
    .dw animEnemyPatruDer ;; puntero a animacion
    .db #0x06 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3 ;vida
    .db 2 ;daño
    .db 0x01           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x10 ;puntos

patrulleroNoPoints::
    .db 50    ;;;; X
    .db 50   ;;;; Y                           
    .db 7    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy           ;;quitar esto para que la patrulla vaya bien
    .db typeEnemy ;;;; tipo de entidad
    .db dropTreasure ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db e_ai_state_standBy   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _patrullero_0 ;;;; sprite
    .dw animEnemyPatruDer ;; puntero a animacion
    .db #0x06 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3 ;vida
    .db 2 ;daño
    .db 0x01           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0 ;puntos


enemigoLateral::
    .db 40    ;;;; X
    .db 30   ;;;; Y                           
    .db 6    ;;;; wi
    .db 10    ;;;; he
    .db 1    ;;;; vX
    .db 0    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db 0x08 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia                ;;PROBLEMON LOCO SI PONGO 0000 PETA, PARECE QUE ENTRA AL UPDATE Y SE LLAMA A 0000 Y EXPLOTA
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _lateral_0 ;;;; sprite
    .dw animEnemyLateralDer ;; puntero a animacion
    .db 0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 2
    .db 2 ;daño
    .db 0x01           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x5 ;puntos

enemigoVertical::
    .db 10   ;;;; X
    .db 120   ;;;; Y                           
    .db 6    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db -3    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider | cmpAnim  ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _vertical_0 ;;;; sprite
    .dw animEnemyVert ;; puntero a animacion
    .db 0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 2 ;vida
    .db 2 ;daño
    .db 0
    .db 0x5 ;puntos


enemigoDiagonal::
    .db 10   ;;;; X
    .db 120   ;;;; Y                           
    .db 7    ;;;; wi
    .db 10    ;;;; he
    .db +1   ;;;; vX
    .db -4    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _diagonal_0 ;;;; sprite
    .dw animEnemyDiag ;; puntero a animacion
    .db 0x03 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 1 ;daño
    .db 0 ;autodestruccion
    .db 0x10 ;puntos

enemigoDiagonalNoPoint::
    .db 10   ;;;; X
    .db 120   ;;;; Y                           
    .db 7    ;;;; wi
    .db 10    ;;;; he
    .db +1   ;;;; vX
    .db -4    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw enemyBehaviour ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _diagonal_0 ;;;; sprite
    .dw animEnemyDiag ;; puntero a animacion
    .db 0x03 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 1 ;daño
    .db 0 ;autodestruccion
    .db 0 ;puntos

turret::
    .db 40   ;;;; X
    .db 100   ;;;; Y                           
    .db 6    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db typeShoot ;; colisiona contra
    .dw aiShooterBehaviour ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 10 ;; contador disparo
    .dw _tower_0 ;;;; sprite
    .dw animEnemyTower ;; puntero a animacion
    .db 0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3  ;vida
    .db 2 ;daño
    .db 0
    .db 0x15 ;puntos

mobileTurret::
    .db 20   ;;;; X
    .db 20   ;;;; Y                           
    .db 7    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db dropTreasure  | mobile ;;;; subtipo de entidad
    .db cmpRender | cmpMovable | cmpIa | cmpCollider | cmpAnim ;; componentes de entidad
    .db 0 ;; colisiona contra
    .dw aiMobileShooterBehaviour ;;; comportamiento ia
    .db e_ai_state_patrol   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw patrol_01   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 20 ;; contador disparo
    .dw _towerMov_0 ;;;; sprite
    .dw animEnemyTowerMovDer ;; puntero a animacion
    .db 0x05 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 3  ;vida
    .db 2 ;daño
    .db 0x01           ;; para animacion: 1 = derecha, 0 = izquierda
    .db 0x20 ;puntos

shot::
    .db 0    ;;;; X
    .db 0   ;;;; Y                           
    .db 1    ;;;; wi
    .db 4    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeShoot ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider ;; componentes de entidad
    .db typeEnemy ;; colisiona contra
    .dw 0x0000 ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _spDisparo_0 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 1 ;daño
    .db 0
    .db 0 ;puntos


enemyShot::
    .db 40    ;;;; X
    .db 90   ;;;; Y                           
    .db 1    ;;;; wi
    .db 4    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeShoot ;;;; tipo de entidad
    .db 1 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider | cmpIa ;; componentes de entidad
    .db typePlayer ;; colisiona contra
    .dw aiMoveTo ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _spDisparo_1 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 1 ;daño
    .db 0
    .db 0 ;puntos

enemyShot2::
    .db 40    ;;;; X
    .db 90   ;;;; Y                           
    .db 1    ;;;; wi
    .db 4    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeShoot ;;;; tipo de entidad
    .db 1 ;;;; subtipo de entidad
    .db cmpRender | cmpMovable  | cmpCollider  ;; componentes de entidad
    .db typePlayer ;; colisiona contra
    .dw 0 ;;; comportamiento ia
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _spDisparo_1 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 1 ;daño
    .db 0
    .db 0 ;puntos

treasure::
    .db 20    ;;;; X
    .db 100  ;;;; Y                           
    .db 4    ;;;; wi
    .db 10    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeTreasure ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpCollider | cmpAutoDestruction;; componentes de entidad
    .db 0 ;; colisiona contra
    .dw 0x0000 ;;; comportamiento 
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _treasure_0 ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 0
    .db 0 ;daño
    .db 0xA0 ;;autodestruccion
    .db 0 ;puntos

healing::
    .db 60    ;;;; X
    .db 100  ;;;; Y                           
    .db 4    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeHealing ;;;; tipo de entidad
    .db 0 ;;;; subtipo de entidad
    .db cmpRender | cmpCollider ;; componentes de entidad
    .db 0 ;; colisiona contra
    .dw 0x0000 ;;; comportamiento 
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _healing ;;;; sprite
    .dw 0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 0       ;;MAXIMO PUEDE SER 9, que es lo que cura
    .db 0 ;daño
    .db 0
    .db 0 ;puntos

    spyke::
    .db 20    ;;;; X
    .db 100   ;;;; Y                           
    .db 4    ;;;; wi
    .db 8    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeEnemy ;;;; tipo de entidad
    .db undying ;;;; subtipo de entidad
    .db cmpRender | cmpCollider  ;; componentes de entidad
    .db 0 ;; colisiona contra
    .dw 0x0000 ;;; comportamiento ia                ;;PROBLEMON LOCO SI PONGO 0000 PETA, PARECE QUE ENTRA AL UPDATE Y SE LLAMA A 0000 Y EXPLOTA
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _spyke ;;;; sprite
    .dw  0x0000 ;; puntero a animacion
    .db 12 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 1
    .db 5 ;daño
    .db 0
    .db 0 ;puntos

    stair::
    .db rightBorder-paddingH-8    ;;;; X
    .db 25   ;;;; Y                           
    .db 8    ;;;; wi
    .db 12    ;;;; he
    .db 0    ;;;; vX
    .db 0    ;;;; vy
    .db typeTreasure ;;;; tipo de entidad
    .db typeStairs ;;;; subtipo de entidad
    .db 0 ;cmpRender | cmpCollider  ;; componentes de entidad
    .db 0 ;; colisiona contra
    .dw 0x0000 ;;; comportamiento ia                ;;PROBLEMON LOCO SI PONGO 0000 PETA, PARECE QUE ENTRA AL UPDATE Y SE LLAMA A 0000 Y EXPLOTA
    .db 0   ;;;; estado de la ia
    .db 0   ;;;; estado Previo de la ia
    .dw 0x0000   ;;;; paso de la patrulla
    .db 0   ;;;; X destino
    .db 0  ;;;; Y destino    
    .db 0 ;; contador disparo
    .dw _stair ;;;; sprite
    .dw  0x0000 ;; puntero a animacion
    .db 0 ;;contador animacion
    .dw 0x0000 ;;zona de memoria de la posicion anterior (para el borrado)
    .db 0
    .db 0 ;daño
    .db 0
    .db 0 ;puntos