.globl cpct_drawStringM0_asm
.globl _mySetDrawCharM0
.globl _myDrawStringM0
.include "game.h.s"

maxCharacters=18
rowDistance=0xa0 ;;para saltar dos filas
screenCenter=0xC3C4
       
;; en iy le llegara la direccion de la frase
;; en hl hay que pasarle la fila de la memoria donde pintaremos la frase
;; en b le llegara el numero de letras de la frase 
;; en c le llegara el color de la frase 
centerPhrase::
    ;;color de la frase
    push bc
    push ix
    push hl
    push af
    push de
    push iy

    ld h, #0x00
    ld l, c
    call _mySetDrawCharM0

    pop iy
    pop de
    pop af
    pop hl
    pop ix
    pop bc

    ld a, #maxCharacters
    sub b
    or a
    rra

    ;hacer bucle que sume "4" el numero de "a" veces, si en "a" hay un 3 hay que hacer 4+4+4, todo esto sumandoselo a hl -> hl + 4 + 4 + 4
    ld de, #4
    cp #0
    jr z, drawPhrase
    loopCenterPhrase:
        add hl, de
        dec a
    jr nz, loopCenterPhrase
    drawPhrase:
    ;con eso ya hemos desplazado la posicion inicial que habia en hl
    ;ya podemos llamar a drawstring, todos los registros estan bien
    ;call cpct_drawStringM0_asm
    call _myDrawStringM0
ret

;en b el numero de frases que tiene el texto
; en hl le pasa el puntero al texto
auxVertical: .db 0
centerTextVertical::

    push hl
    pop iy      ;;metemos la direccion del texto en iy

    ld a,b
    ld (auxVertical),a  ;;guardamos el numero de filas en un auxiliar para operar con el

    ;;******************cuidado que si nos pasan una frase vacia se lia parda  ***********************
    ld hl, #screenCenter      ;
            ; nos pasan el N de frases, si hay 1 no se hace nada si hay mas de 1 se resta  50 por cada una que haya
    dec b
    jr z,onePhrase
        loopVertical: ;;colocamos HL en la linea de la cual partimos
        ld de,#rowDistance
        or a 
        sbc hl,de
        dec b
        jr nz,loopVertical
    onePhrase:               ;; ya tenemos HL donde queremos ahora escribimos linea y sumamos 100 a hl para llegar a la siguiente
        phrasesLoop:

        ld a,1(iy) ;;parte baja de la direccion de la frase
        ld e,a
        ld a,2(iy)  ;;parte alta de la direccion de la frase
        ld d,a
        push iy     ;;posicion en el array de palabras
        push hl     ;posicion de memoria de video

        push bc
        ld b,(iy)  ;; numero de letras de la frase
        ld c, 3(iy) 
        push de     ;;metemos en de la direccion de la palabra
        pop iy      ;;metemos en iy la posicion de memoria de la palabra
       
        
        ;;hl ya está en el sitio
        call centerPhrase
        
        pop bc
       
        pop hl      ;;recuperamos la direccion de video en la que estamos
        pop iy      ;;recuperamos la frase en la que estamos
        ld de,#rowDistance
        add hl,de   ;;avanzamos a la siguiente direccion de video a la que vamos a escribir
        inc iy
        inc iy      ;;avanzamos a la siguiente frase que vamos a escribir
        inc iy
        inc iy

        ld a,(auxVertical) ;;recuperamos el numero de frases
        dec a       ;;decrementamos el numero de frases que faltan por escribir
        ld (auxVertical),a
    jr nz,phrasesLoop



    ;; en iy tiene que estar puntero a texto
    ;; en hl hay que pasarle la fila de la memoria donde pintaremos la frase
    ;; en b le llegara el numero de letras de la frase 
    ;call centerPhrase


ret

;en b se recibe el nivel por el que vamos
writeTextLevel::

    ld ix,#arrayTextLevels   ;   4000
    dec b
    jr z,endSelection
        loopSelectText:
            ld de,#3
            add ix,de   ;;pasamos al siguiente texto
            dec b
            jr nz,loopSelectText
        endSelection:

    ld b,(ix) ;;numero de frases
    ld a,1(ix) ;;parte pequeña
    ld l,a
    ld a,2(ix)  ;;parte grande
    ld h,a
    call centerTextVertical     ;;pasamos numero de frases y direccion del texto
ret


arrayTextLevels::
    .db 3           ;;contador de frases que tiene el texto
    .dw text1       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text2       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text3       ;;puntero del texto
    .db 2           ;;contador de frases que tiene el texto
    .dw text4       ;;puntero del texto
    .db 4          ;;contador de frases que tiene el texto
    .dw text5       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text6       ;;puntero del texto
    .db 4           ;;contador de frases que tiene el texto
    .dw text7      ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text8       ;;puntero del texto
    .db 2           ;;contador de frases que tiene el texto
    .dw text9       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text10       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text12       
    .db 3           ;;intercambio por continuidad
    .dw text11       
    .db 3           ;;contador de frases que tiene el texto
    .dw text13       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text14       ;;puntero del texto
    .db 1           ;;contador de frases que tiene el texto
    .dw text15       ;;puntero del texto
    .db 2           ;;contador de frases que tiene el texto
    .dw text16       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text17       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text18       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text19       ;;puntero del texto
    .db 4           ;;contador de frases que tiene el texto
    .dw text20       ;;puntero del texto
    .db 3           ;;contador de frases que tiene el texto
    .dw text21       ;;puntero del texto


arrayTextLore::
    .db 4
    .dw textL1
    .db 4
    .dw textL2


textL1:
    .db sizeLore1           ;;numero de caracteres de la frase
    .dw lore1     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizeLore2
    .dw lore2
    .db 0x0F
    .db sizeLore3
    .dw lore3
    .db 0x0F
    .db sizeLore4
    .dw lore4
    .db 0x0A

lore1:: .asciz "WE HAVE REPORTS OF"  
sizeLore1=.-lore1-1
lore2:: .asciz " STRANGE CREATURES"  
sizeLore2=.-lore2-1
lore3:: .asciz "CLOSE TO THE"  
sizeLore3=.-lore3-1
lore4:: .asciz "RAD-TOWN"
sizeLore4=.-lore4-1


textL2:   
    .db sizePhrase34        ;;numero de caracteres de la frase
    .dw phrase34     ;;puntero de la frase               04  00 40
    .db 0x04
    .db sizePhrase35
    .dw phrase35
    .db 0x0F
    .db sizePhrase36
    .dw phrase36
    .db 0x0F
    .db sizeLore5           ;;numero de caracteres de la frase
    .dw lore5     ;;puntero de la frase               04  00 40
    .db 0x0D

lore5:: .asciz "SIR, YES SIR!!"  
sizeLore5=.-lore5-1



text1::
    .db sizePhrase1           ;;numero de caracteres de la frase
    .dw phrase1     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase2
    .dw phrase2
    .db 0x0B
    .db sizePhrase3
    .dw phrase3
    .db 0x0D

phrase1:: .asciz "WATCH YOUR"  
sizePhrase1=.-phrase1-1
phrase2:: .asciz "ENEMY DETECTOR"  
sizePhrase2=.-phrase2-1
phrase3:: .asciz "GOT IT"  
sizePhrase3=.-phrase3-1



text2::
    .db sizePhrase4           ;;numero de caracteres de la frase
    .dw phrase4     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase5
    .dw phrase5
    .db 0x0F
    .db sizePhrase6
    .dw phrase6
    .db 0x04

phrase4:: .asciz "THERE ARE SUPPLIES"  
sizePhrase4=.-phrase4-1
phrase5:: .asciz "EVERY 5 FLOORS"  
sizePhrase5=.-phrase5-1
phrase6:: .asciz "DESCEND TO THE 21!"  
sizePhrase6=.-phrase6-1

text3::
    .db sizePhrase7           ;;numero de caracteres de la frase
    .dw phrase7     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase8
    .dw phrase8
    .db 0x0F
    .db sizePhrase9
    .dw phrase9
    .db 0x0A

phrase7:: .asciz "TRY TO COLLECT"  
sizePhrase7=.-phrase7-1
phrase8:: .asciz "AND SECURE"  
sizePhrase8=.-phrase8-1
phrase9:: .asciz "URANIUM SHARDS"  
sizePhrase9=.-phrase9-1

text4::
    .db sizePhrase10           ;;numero de caracteres de la frase
    .dw phrase10     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase11
    .dw phrase11
    .db 0x0F

phrase10:: .asciz "STAY TUNED"  
sizePhrase10=.-phrase10-1
phrase11:: .asciz "TO GET MORE INFO"  
sizePhrase11=.-phrase11-1

text5::
    .db sizePhrase12           ;;numero de caracteres de la frase
    .dw phrase12     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase13
    .dw phrase13
    .db 0x0F
    .db sizePhrase14
    .dw phrase14
    .db 0x0F
    .db sizePhrase15
    .dw phrase15
    .db 0x04

phrase12:: .asciz "FIRST ZONE CLEARED"  
sizePhrase12=.-phrase12-1
phrase13:: .asciz "YOU ARE ENTERING"  
sizePhrase13=.-phrase13-1
phrase14:: .asciz "A HIGH DANGER ZONE"  
sizePhrase14=.-phrase14-1
phrase15:: .asciz "WATCH YOUR STEPS"  
sizePhrase15=.-phrase15-1

text6::
    .db sizePhrase16           ;;numero de caracteres de la frase
    .dw phrase16     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase17
    .dw phrase17
    .db 0x0D
    .db sizePhrase18
    .dw phrase18
    .db 0x0D

phrase16:: .asciz "WHAT HAPPENED TO"  
sizePhrase16=.-phrase16-1
phrase17:: .asciz "THE RECON TEAM"  
sizePhrase17=.-phrase17-1
phrase18:: .asciz "MAJOR?"  
sizePhrase18=.-phrase18-1


text7::
    .db sizePhrase19           ;;numero de caracteres de la frase
    .dw phrase19     ;;puntero de la frase               04  00 40
    .db 0x04
    .db sizePhrase20
    .dw phrase20
    .db 0x0F
    .db sizePhrase21
    .dw phrase21
    .db 0x0F
    .db sizePhrase22
    .dw phrase22
    .db 0x0F

phrase19:: .asciz "WE LOST CONTACT."  
sizePhrase19=.-phrase19-1
phrase20:: .asciz "YOU MAY FIND"  
sizePhrase20=.-phrase20-1
phrase21:: .asciz "THEIR SUPPLIES"  
sizePhrase21=.-phrase21-1

phrase22:: .asciz "DOWN THERE"  
sizePhrase22=.-phrase22-1


text8::
    .db sizePhrase23         ;;numero de caracteres de la frase
    .dw phrase23     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase24
    .dw phrase24
    .db 0x04
    .db sizePhrase25
    .dw phrase25
    .db 0x0F

phrase23:: .asciz "I FOUND A MEDKIT"  
sizePhrase23=.-phrase23-1
phrase24:: .asciz "INSIDE A CREATURE"  
sizePhrase24=.-phrase24-1
phrase25:: .asciz "STAY FOCUSED...."  
sizePhrase25=.-phrase25-1


text9::
    .db sizePhrase26         ;;numero de caracteres de la frase
    .dw phrase26     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase27
    .dw phrase27
    .db 0x0D

phrase26:: .asciz "WHATS YOUR STATUS?"  
sizePhrase26=.-phrase26-1
phrase27:: .asciz "ENTERING ZONE 2"  
sizePhrase27=.-phrase27-1


text10::
    .db sizePhrase28         ;;numero de caracteres de la frase
    .dw phrase28     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase29
    .dw phrase29
    .db 0x04
    .db sizePhrase30
    .dw phrase30
    .db 0x04

phrase28:: .asciz "WE HAVE REPORTS OF"  
sizePhrase28=.-phrase28-1
phrase29:: .asciz "CREATURES SHOOTING"  
sizePhrase29=.-phrase29-1
phrase30:: .asciz "PROJECTILES"  
sizePhrase30=.-phrase30-1

text11::
    .db sizePhrase31         ;;numero de caracteres de la frase
    .dw phrase31     ;;puntero de la frase               04  00 40
    .db 0x0B
    .db sizePhrase32
    .dw phrase32
    .db 0x0F
    .db sizePhrase33
    .dw phrase33
    .db 0x0F

phrase31:: .asciz "9 FLOORS LEFT"  
sizePhrase31=.-phrase31-1
phrase32:: .asciz "REMEMBER THE"  
sizePhrase32=.-phrase32-1
phrase33:: .asciz "MISSION!"  
sizePhrase33=.-phrase33-1

text12::
    .db sizePhrase34        ;;numero de caracteres de la frase
    .dw phrase34     ;;puntero de la frase               04  00 40
    .db 0x04
    .db sizePhrase35
    .dw phrase35
    .db 0x0D
    .db sizePhrase36
    .dw phrase36
    .db 0x0D

phrase34:: .asciz "SEARCH AND DESTROY"  
sizePhrase34=.-phrase34-1
phrase35:: .asciz "THE NEST"  
sizePhrase35=.-phrase35-1
phrase36:: .asciz "OF THE CREATURES!!"  
sizePhrase36=.-phrase36-1


text13::
    .db sizePhrase37        ;;numero de caracteres de la frase
    .dw phrase37     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase38
    .dw phrase38
    .db 0x0F
    .db sizePhrase39
    .dw phrase39
    .db 0x0D

phrase37:: .asciz "DO YOU ......."  
sizePhrase37=.-phrase37-1
phrase38:: .asciz "...RECIEVE......"  
sizePhrase38=.-phrase38-1
phrase39:: .asciz "MAJOR?!?!?"  
sizePhrase39=.-phrase39-1

text14::
    .db sizePhrase40        ;;numero de caracteres de la frase
    .dw phrase40     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase41
    .dw phrase41
    .db 0x0F
    .db sizePhrase42
    .dw phrase42
    .db 0x0F

phrase40:: .asciz "WE ARE LOSING..."  
sizePhrase40=.-phrase40-1
phrase41:: .asciz "...CONTACT...."  
sizePhrase41=.-phrase41-1
phrase42:: .asciz "FINISH THE MISSION"  
sizePhrase42=.-phrase42-1

text15::
    .db sizePhrase43        ;;numero de caracteres de la frase
    .dw phrase43     ;;puntero de la frase               04  00 40
    .db 0x0D


phrase43:: .asciz "IM ALONE NOW.."  
sizePhrase43=.-phrase43-1


text16::
    .db sizePhrase44        ;;numero de caracteres de la frase
    .dw phrase44     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase45
    .dw phrase45
    .db 0x0D


phrase44:: .asciz "........."  
sizePhrase44=.-phrase44-1
phrase45:: .asciz "NO SIGNAL.."  
sizePhrase45=.-phrase45-1



text17::
    .db sizePhrase47       ;;numero de caracteres de la frase
    .dw phrase47     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase48
    .dw phrase48
    .db 0x0D
    .db sizePhrase49
    .dw phrase49
    .db 0x04

phrase47:: .asciz "I HEAR...."  
sizePhrase47=.-phrase47-1
phrase48:: .asciz "..THOSE BATS.."  
sizePhrase48=.-phrase48-1
phrase49:: .asciz "LOTS OF THEM!!"  
sizePhrase49=.-phrase49-1


text18::
    .db sizePhrase50       ;;numero de caracteres de la frase
    .dw phrase50     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase51
    .dw phrase51
    .db 0x0D
    .db sizePhrase52
    .dw phrase52
    .db 0x0D

phrase50:: .asciz "THE RADIATION"  
sizePhrase50=.-phrase50-1
phrase51:: .asciz "LEVELS ARE TOO"  
sizePhrase51=.-phrase51-1
phrase52:: .asciz "HIGH DOWN HERE"  
sizePhrase52=.-phrase52-1

text19::
    .db sizePhrase53       ;;numero de caracteres de la frase
    .dw phrase53     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase54
    .dw phrase54
    .db 0x0D
    .db sizePhrase55
    .dw phrase55
    .db 0x0B

phrase53:: .asciz "IM ALMOST THERE!"  
sizePhrase53=.-phrase53-1
phrase54:: .asciz "LETS REST A LITTLE"  
sizePhrase54=.-phrase54-1
phrase55:: .asciz "BETTER BE PREPARED"  
sizePhrase55=.-phrase55-1

text20::
    .db sizePhrase56       ;;numero de caracteres de la frase
    .dw phrase56     ;;puntero de la frase               04  00 40
    .db 0x0D
    .db sizePhrase57
    .dw phrase57
    .db 0x0D
    .db sizePhrase58
    .dw phrase58
    .db 0x0D
    .db sizePhrase59
    .dw phrase59
    .db 0x0D

phrase56:: .asciz "ONE SEEMS"  
sizePhrase56=.-phrase56-1
phrase57:: .asciz "DANGEROUS!"  
sizePhrase57=.-phrase57-1
phrase58:: .asciz "THE OTHER"  
sizePhrase58=.-phrase58-1
phrase59:: .asciz "SEEMS VERY ANGRY.."  
sizePhrase59=.-phrase59-1


text21::
    .db sizePhrase60       ;;numero de caracteres de la frase
    .dw phrase60     ;;puntero de la frase               04  00 40
    .db 0x0F
    .db sizePhrase61
    .dw phrase61
    .db 0x0F
    .db sizePhrase62
    .dw phrase62
    .db 0x0F
phrase60:: .asciz "MISSION COMPLETED!"  
sizePhrase60=.-phrase60-1
phrase61:: .asciz "GOOD JOB"  
sizePhrase61=.-phrase61-1
phrase62:: .asciz "GET OUT OF THERE"  
sizePhrase62=.-phrase62-1







