.include "../manager/entity.h.s"
.include "../manager/patrol.h.s"
.include "../manager/template.h.s"
.include "physics.h.s"
.include "../manager/level.h.s"
.include "../manager/game.h.s"
.include "../manager/animation.h.s"


.globl _cpct_getRandom_mxor_u8


movBoss1:: .db 0     ;; animacion boss: 0 = derecha; 1 = izquierda
movBoss2:: .db 0     ;; animacion boss: 0 = derecha; 1 = izquierda

radioX=30
radioY=60

aiUpdateEntity::

    ld e, e_behaviour2(ix)
    ld d, e_behaviour1(ix) 

    ld hl,#returnAiUpdate
    push hl
    ex de, hl
    jp (hl)

    returnAiUpdate:
ret

aiUpdate::
    ld de, #aiUpdateEntity
    ld a,#cmpIa
    call doBySignature
ret


bossBehaviour::


    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_wait
    jr z,wait1

    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_moveTo 
    jr z,moveBoss1
      
    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_patrol 
    jr z,bosspatrol


    wait1:
    call aiWaitBossAction
    ret

    moveBoss1:
    call aiMoveTo
    ret

    bosspatrol:
    call aiPatrol
    ret


ret


bossBehaviour2::


    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_wait
    jr z,wait2

    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_moveTo 
    jr z,moveBoss2
      
    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_patrol 
    jr z,bosspatrol2


    wait2:
    call aiWaitBossAction2
    ret

    moveBoss2:
    call aiMoveTo
    ret

    bosspatrol2:
    call aiPatrol
    ret


ret


enemyBehaviour::

    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_moveTo 
    jr z,move
      
    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_patrol 
    jr z,patrol
    
    ld a,e_AIState(ix)
    or a
    cp #e_ai_state_standBy                 
    jr z,stand


    move:
    call aiMoveTo
    ret

    patrol:
    call aiPatrol
    ret

    stand:
    call aiStandBy
    ret
ret


shotSpeedTurret=30
aiShooterBehaviour::            ;; disparo a la ultima posicion del jugador cada x frames


    ld a,e_shootCounter(ix)                ;;metemos un 5 en a
    dec a                           ;; restamos 1
    ld e_shootCounter(ix) ,a                ;;guardamos 4 en ShotTimer
    ret nz

   
        call aiShootTo              ;;si es cero llamamos a la funcion de disparar
       
    ld a,#shotSpeedTurret
    ld e_shootCounter(ix) ,a
    ret

ret

shotSpeedMobile=30
aiMobileShooterBehaviour::
    ld a,e_shootCounter(ix)         ;; calculamos cuanto falta para disparar       
    dec a                           
    ld e_shootCounter(ix),a
    jr z,ShootTime
        
        ld a,e_AIState(ix)
        cp #e_ai_state_patrol
        call z,aiPatrol

        cp #e_ai_state_moveTo
        call z,aiMoveTo
        ret

    ShootTime:
    call aiShootTowards              ;;si es cero llamamos a la funcion de disparar
    ld a,#shotSpeedMobile
    ld e_shootCounter(ix) ,a
    

ret


fullWaitTime=0x20
waitTime=0x10
waitShot=0x10
SpawnWaitTime=0x70

auxBoss: .db 0      
aiWaitBossAction::       ;;podria hacer un patrullero mejorado con el move to de por medio para que vaya a por el jugador de forma inesperada
    ld a,e_destroyCounter(ix)
    cp #0
    jr nz, doNothing

        ;;tirar un random y elegir entre varias acciones
        call _cpct_getRandom_mxor_u8    ;; Obtenemos un numero aleatorio,  se carga todos los registros, el resultado esta en L
        ld a,l                          ;; metemos el valor obtenido en A
        and #0x07
        ld (auxBoss),a

        cp #0
        jr nz,noShooting
        disparar:
         call aiShootTo
         ld a,#waitShot
         ld e_destroyCounter(ix),a
         ret

        noShooting:
        
        cp #1
        jr nz,noShoot2
           jr disparar
        ret
        noShoot2:

        cp #3
        jr nz,noAtack
        atacarPlayer:
                                     ;;moverse al jugador y volver a patrullar
        call aiGetPlayerPosition
            ld a,#e_ai_state_moveTo  ;obtengo la posicion del player y llamo a move to
            ld e_AIPrevState(ix),#e_ai_state_wait
            ld e_AIState(ix),a
            ld a,#waitTime
            ld e_destroyCounter(ix),a
        ret
        noAtack:

        ld a,(auxBoss)
        cp #4
        jr nz,noChase
            jr disparar
        ret
        noChase:

         ;ld a,(auxBoss)
        cp #5
        jr nz,noChase3
            jr atacarPlayer
        ret
        noChase3:

       ; ld a,(auxBoss)
        cp #6
        jr nz,noChase4
            jr atacarPlayer
        ret
        noChase4:
        
        keepPatrolling:
        ;;los demas numeros es pasar de punto
        ld a,#e_ai_state_patrol
        ld e_AIPrevState(ix),#e_ai_state_wait
        ld e_AIState(ix),a

        ld a,#fullWaitTime
        ld e_destroyCounter(ix),a
        ret

    doNothing:
    dec a
    ld e_destroyCounter(ix),a

ret

enemysScreen:: .db 0
limitScreen= 1
aiWaitBossAction2::       ;;podria hacer un patrullero mejorado con el move to de por medio para que vaya a por el jugador de forma inesperada
    ld a,e_destroyCounter(ix)
    cp #0
    jp nz, doNothing2

        ;;tirar un random y elegir entre varias acciones
        call _cpct_getRandom_mxor_u8    ;; Obtenemos un numero aleatorio,  se carga todos los registros, el resultado esta en L
        ld a,l                          ;; metemos el valor obtenido en A
        and #0x07
        ld (auxBoss),a

        cp #0
        jr nz,noZomb
            ld a,(enemysScreen)
            cp #limitScreen
            jp z,disparar2
                ld hl,#zombiNoPoints
                ld a,e_x(ix)
                ld b,a
                ld a,e_y(ix)
                ld c,a
                call createEntityInPlace
                ld a,(numEnemies)
                inc a
                ld (numEnemies), a 
                ld a,(enemysScreen)
                inc a
                ld (enemysScreen),a

                ld a,#waitTime
                ld e_destroyCounter(ix),a
         ret

        noZomb:
        
        cp #1
        jr nz,noReinforcement
             ld a,(enemysScreen)
            cp #limitScreen
            jr z,disparar2
                ld hl,#enemigoDiagonalNoPoint
                ld a,e_x(ix)
                ld b,a
                ld a,e_y(ix)
                ld c,a
                call createEntityInPlace
                ld a,(numEnemies)
                inc a
                ld (numEnemies), a 
                ld a,(enemysScreen)
                inc a
                ld (enemysScreen),a

                ld a,#waitTime
                ld e_destroyCounter(ix),a 
        ret
        
        noReinforcement:

        cp #2
        jr nz,noReinforcement2
            ld a,(enemysScreen)
            cp #limitScreen
            jr z,noShooting3
                ld hl,#enemigoDiagonalNoPoint
                ld a,e_x(ix)
                ld b,a
                ld a,e_y(ix)
                ld c,a
                call createEntityInPlace
                ld a,(numEnemies)
                inc a
                ld (numEnemies), a
                ld a,(enemysScreen)
                inc a
                ld (enemysScreen),a

                ld a,#waitTime
                ld e_destroyCounter(ix),a 
        ret
        noReinforcement2:

        cp #3
        jr nz,noShooting3
        disparar2:
         call aiShootTo
         ld a,#waitShot
         ld e_destroyCounter(ix),a
         ret
        
        noShooting3:

    
        ;;los demas numeros es pasar de punto
        ld a,#e_ai_state_patrol
        ld e_AIPrevState(ix),#e_ai_state_wait
        ld e_AIState(ix),a

        ld a,#fullWaitTime
        ld e_destroyCounter(ix),a
        ret

    doNothing2:
    dec a
    ld e_destroyCounter(ix),a

ret


aiStandBy::
    
    call getPatrolRandom

    ld e_AIPatrolStep2(ix),l
    ld e_AIPatrolStep1(ix),h
    ld e_AIPrevState(ix),#e_ai_state_standBy
    ld e_AIState(ix),#e_ai_state_patrol
ret

aiMoveTo::
    
    ld a,e_targetx(ix)
    sub e_x(ix)
    jr nc, targetXGreaterOrEqual
        targetXLesser:                          ;;targetXNotGreater:
            ld e_vx(ix),#-1

                ld a, e_subType(ix) 
                ld b, #bossSubType
                sub b
                jp z, endifX

                ld a, e_subType(ix) 
                ld b, #bossSubType2
                sub b
                jp z, endifX


                ;; es patrullero
                ld a, e_subType(ix) 
                ld b, #0x81
                sub b
                jr z, noPatruX
                
                ld a, e_destroyCounter(ix)
                add #0
                jp z, endifX

                    ld e_animPointer2(ix), #<animEnemyPatruIzq
                    ld e_animPointer1(ix), #>animEnemyPatruIzq

                    ld a, #0
                    ld e_destroyCounter(ix), a

                jp endifX
            
            noPatruX:   ;; torreta movil
                ld a, e_destroyCounter(ix)
                add #0
                jr z, endifX

                    ld e_animPointer2(ix), #<animEnemyTowerMovIzq
                    ld e_animPointer1(ix), #>animEnemyTowerMovIzq
                    
                    ld a, #0
                    ld e_destroyCounter(ix), a

            jr endifX

        targetXGreaterOrEqual:
            jr z,arrivedX
                ld e_vx(ix),#1

                    ld a, e_subType(ix) 
                    ld b, #bossSubType
                    sub b
                    jr z, endifX

                    ld a, e_subType(ix) 
                    ld b, #bossSubType2
                    sub b
                    jr z, endifX


                ld a, e_subType(ix)
                ld b, #0x81
                sub b
                jr z, noPatruY

                
                    ;; es patrullero
                    ld a, e_destroyCounter(ix)
                    add #0
                    jr nz, endifX

                    ld e_animPointer2(ix), #<animEnemyPatruDer
                    ld e_animPointer1(ix), #>animEnemyPatruDer

                    ld a, #1
                    ld e_destroyCounter(ix), a

                jr endifX

            noPatruY:   ;; torreta movil
                ld a, e_destroyCounter(ix)
                add #0
                jr nz, endifX

                    ld e_animPointer2(ix), #<animEnemyTowerMovDer
                    ld e_animPointer1(ix), #>animEnemyTowerMovDer

                    ld a, #1
                    ld e_destroyCounter(ix), a

            jr endifX

        arrivedX:
            ld e_vx(ix),#0
           
    endifX:

     ld a,e_targety(ix)
     sub e_y(ix)
     jr nc, targetYGreaterOrEqual
         targetYLesser:                          ;;targetXNotGreater:
             ld e_vy(ix),#-2
             jr endifY

         targetYGreaterOrEqual:
             jr z,arrivedY
             ld e_vy(ix),#2
             jr endifY

         arrivedY:
            ld e_vy(ix),#0
            ld a,e_vx(ix)
            add #0
            jr nz, endifY

                ld a,e_type(ix)
                cp #typeShoot
                jr z,destinationReached
                
                ld a,e_type(ix)
                cp #typeSpawn
                call z, spawnEnemy

                ld a,e_subType(ix)
                cp #bossSubType
                jr z,bossStateChange
                cp #bossSubType2
                 jr z,bossStateChange

                ld a,e_AIPrevState(ix)
                ld e_AIPrevState(ix),#e_ai_state_moveTo
                ld e_AIState(ix),a

                ret

                bossStateChange:

                    ld a,#e_ai_state_wait
                    ld e_AIPrevState(ix),#e_ai_state_moveTo
                    ld e_AIState(ix),a

                ret

            destinationReached:
            call markShot
            
    endifY:
ret

aiPatrol::
 ld l, e_AIPatrolStep2(ix)
 ld h, e_AIPatrolStep1(ix)

 ld a,(hl)
 cp #patrolInvalidMove
 jr z,resetPatrol

 ld e_targetx(ix),a
 inc hl
 ld a ,(hl)
 ld e_targety(ix),a

 inc hl
 ld e_AIPatrolStep2(ix),l
 ld e_AIPatrolStep1(ix),h


 ld e_AIPrevState(ix),#e_ai_state_patrol
 ld e_AIState(ix),#e_ai_state_moveTo


ret

resetPatrol:
 inc hl
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld e_AIPatrolStep2(ix),a
 ld e_AIPatrolStep1(ix),h
ret


aiChase::
    call aiGetPlayerPosition
    ;call aiMoveTo
    ld a,e_targetx(ix)
    sub e_x(ix)
    jr nc, targetXGreaterOrEqual2
        targetXLesser2:                          ;;targetXNotGreater:
            ld e_vx(ix),#-1

            ld a, e_destroyCounter(ix)
            add #0
            jr z, endifX2

                ld e_animPointer2(ix), #<animEnemyZombieIzq
                ld e_animPointer1(ix), #>animEnemyZombieIzq

                ld a, #0
                ld e_destroyCounter(ix), a

            jr endifX2

        targetXGreaterOrEqual2:
            jr z,arrivedX2
                ld e_vx(ix),#1

                ld a, e_destroyCounter(ix)
                add #0
                jr nz, endifX2

                    ld e_animPointer2(ix), #<animEnemyZombieDer
                    ld e_animPointer1(ix), #>animEnemyZombieDer

                    ld a, #1
                    ld e_destroyCounter(ix), a

                jr endifX2

        arrivedX2:
            ld e_vx(ix),#0

         
    endifX2:

     ld a,e_targety(ix)
     sub e_y(ix)
     jr nc, targetYGreaterOrEqual2
         targetYLesser2:                          ;;targetXNotGreater:
             ld e_vy(ix),#-1
             jr endifY2

         targetYGreaterOrEqual2:
             jr z,arrivedY2
             ld e_vy(ix),#1
             jr endifY2

         arrivedY2:
            ld e_vy(ix),#0
            ld a,e_vx(ix)
            add #0
            jr nz, endifY2
            ;ld e_AIState(ix),#e_ai_state_standBy
    endifY2:

ret

aiShootTo::

    ld a, (contEnemyShot)
    ld b, a
    ld a, (maxEnemyShots)
    sub b
    ret z 
   ; jr z, noSpace   ;;maximo de disparos creados
    ;;puede crear nuevo disparo

      ld hl,#enemyShot
      call createEntity
    ;;actualizar contador
      ld a, (contEnemyShot)
      inc a
      ld (contEnemyShot), a

  ;noSpace:

   
    ld hl, (_nextEntity)        
    ld bc, #sizeEntity
    sbc hl, bc                  ;;aqui esta la bala enemiga
    push ix
    push hl
    push hl         ;;inicio de la balaEnemiga recien creada    ;;llamar al move to de la bala desde aqui y luego destruirla
    pop iy

    ld a,e_x(ix)
    add #2
    ld e_x(iy),a        ;;spawneamos la bala donde la torreta
    ld a,e_y(ix)
    add #2
    ld e_y(iy),a

    pop ix
    call aiGetPlayerPosition
    ld a,e_targety(ix)
    add #4
    ld e_targety(ix),a
     ld a,e_targetx(ix)
    add #4
    ld e_targetx(ix),a
    ;ld e_AIPrevState(ix),#e_ai_state_shot
    pop ix
   
ret


aiShootTowards::

    ld a, (contEnemyShot)
    ld b, a
    ld a, (maxEnemyShots)
    sub b
    ret z
   ; jr z, noSpace   ;;maximo de disparos creados
    ;;puede crear nuevo disparo

      ld hl,#enemyShot2
      call createEntity
    ;;actualizar contador
      ld a, (contEnemyShot)
      inc a
      ld (contEnemyShot), a


    ld hl, (_nextEntity)        
    ld bc, #sizeEntity
    sbc hl, bc                  ;;aqui esta la bala enemiga
    push ix
    push hl         ;;inicio de la bala creada
    push hl         ;;inicio de la balaEnemiga recien creada    ;;llamar al move to de la bala desde aqui y luego destruirla
    pop iy

    ld a,e_x(ix)
    add #2
    ld e_x(iy),a        ;;spawneamos la bala donde la torreta
    ld a,e_y(ix)
    add #2
    ld e_y(iy),a

    pop ix

    call aiGetPlayerPosition
                                                    ;x-y si no hay carry es que x es mas grande que y
        ld a,e_targetx(ix)     
        sub e_x(ix)
        jr nc, enemyXGreaterOrEqual
            XLesser:
                jr z,xPerfect                        
                ld e_vx(ix),#-2
                jr endifXx
            enemyXGreaterOrEqual:
                ld e_vx(ix),#2
                jr endifXx
                xPerfect:
                ld e_vx(ix),#0
        endifXx:
        ld a,e_targety(ix)
        sub e_y(ix)
        jr nc, enemyYGreaterOrEqual
            YLesser: 
                jr z,yPerfect                         
                ld e_vy(ix),#-4
                jr endifYy
            enemyYGreaterOrEqual:
                ld e_vy(ix),#4
                jr endifYy
            yPerfect:
             ld e_vy(ix),#0
        endifYy:
     pop ix


ret
aiGetPlayerPosition::
    ld iy,#_arrayEntities  ;;cogemos el player

    ld a,e_x(iy)
    ld e_targetx(ix),a
    ld a,e_y(iy)
    ld e_targety(ix),a
ret
