.include "../manager/entity.h.s"
.include "../manager/game.h.s"
.include "../manager/level.h.s"
.include "render.h.s"
.include "physics.h.s"
.globl cpct_akp_SFXPlay_asm

collisionMarginW=2
collisionMarginH=2
collisionPairs::

    ld a, e_collide(ix)                  ;; en a guardamos con que colisiona la entidad de la izquierda
    and e_type(iy)                    ;;comprobamos si colisionan las entidades
    ld b,a                      ;; TENEMOS EN B SI COLISIONA IZQUIERDA CON DERECHA    
    ld a, e_collide(iy)                  ;; en a guardamos con que colisiona la entidad de la derecha
    and e_type(ix)                    ;; TENEMOS EN A SI COLISIONA DERECHA CON IZQUIERDA

    or b                        ;; a | b (si da 0 es que no colisionan ninguna entre si)
    jp z, noColisionan  

        ld a,e_type(ix)
        and #typePlayer
        sub #typePlayer
        jp nz,isNotPlayer
            ; E izquierda
            ld a,e_x(ix)  ;;metemos la x en a
            add e_wi(ix)    ;;sumamos la ancuhra
            sub #collisionMarginW
            sub e_x(iy)    ;restamos a a la x de la entidad derecha
            jp c,noBox
            ;jr c menor que zero si estamos restando solo

            ;;  E derecha
            ld a,e_x(iy)  ;;metemos la x en a
            add e_wi(iy)
            sub #collisionMarginW
            sub e_x(ix)    ;restamos a a la x de la entidad derecha
            jp c,noBox

            ;;;;;;;;;;;;;;;;;;;;COMPROBACION EJE Y

            ld a,e_y(ix)  ;;metemos la y en a
            add e_he(ix)
            sub #collisionMarginH
            sub e_y(iy)    ;restamos a a la y de la entidad derecha
            jr c,noBox

        
            ld a, e_y(iy)  ;;metemos la y en a
            add e_he(iy)
            sub #collisionMarginH
            sub e_y(ix)    ;restamos a a la y de la entidad derecha
            jp c,noBox

            jp yesCollision

        isNotPlayer:
        ;; E izquierda
        ld a,e_x(ix)  ;;metemos la x en a
        add e_wi(ix)    ;;sumamos la ancuhra
        sub e_x(iy)    ;restamos a a la x de la entidad derecha
        jr c,noBox

        ;;  E derecha
        ld a,e_x(iy)  ;;metemos la x en a
        add e_wi(iy)
        sub e_x(ix)    ;restamos a a la x de la entidad derecha
        jr c,noBox

        ;;;;;;;;;;;;;;;;;;;;COMPROBACION EJE Y

        ld a,e_y(ix)  ;;metemos la y en a
        add e_he(ix)
        sub e_y(iy)    ;restamos a a la y de la entidad derecha
        jr c,noBox

       
        ld a, e_y(iy)  ;;metemos la y en a
        add e_he(iy)
        sub e_y(ix)    ;restamos a a la y de la entidad derecha
        jr c,noBox


        yesCollision:

        call collisionBehaviour

        push ix
        push iy

        push iy
        pop ix      ;;llamar aqui a funcion creo

        ;call markEntity

        pop iy
        pop ix




        jr noColisionan
        noBox:


    noColisionan:
ret



updateCollision::
    ld de, #collisionPairs
    ld a,#cmpCollider
    call doBySignaturePairs
ret

;; en ix la entidad de la izquierda
;; en iy la entidad de la derecha

collisionBehaviour::

        ld a,#typePlayer
        and e_type(ix)
        ld b,#typePlayer
        sub b
        jr nz,noPlayerCollide
            ;;si es jugador
            call collisionBehaviourPlayer
        
        noPlayerCollide:

        ld a,#typeShoot
        and e_type(ix)
        ld b,#typeShoot
        sub b
        jr nz,noShootCollide
            ;;si es jugador
            call collisionBehaviourShot
        
        noShootCollide:

        ld a,#typeEnemy
        and e_type(ix)
        ld b,#typeEnemy
        sub b
        jr nz,noEnemyCollide
            ;;si es jugador
            call collisionBehaviourEnemy
        
        noEnemyCollide:

        
ret


;; se mira con que ha colisionado el jugador y se llama a las funciones pertinentes
collisionBehaviourPlayer::
    
        ld a,#typeTreasure
        and e_type(iy)
        ld b, #typeTreasure
        sub b
        jr nz, noTreasureCollidePlayer


            ;;compruebo el subtipo del tesoro
            ld a,#typeStairs
            and e_subType(iy)
            ld b, #typeStairs
            sub b
            jr nz, notStairs

                push af
                push bc
                push hl
                push de
                push ix
                push iy


                ;El player ha colisionado con una escalera
                ld a, (lvlActual)
                inc a
                ld (lvlActual), a   ; siguiente nivel

                ld a, (levelScreen)
                inc a
                daa
                ld (levelScreen),a
                or a

                ld a, #0
                ld (contSpawn), a
                ld (contEnemyShot),a

                call  nextLevelByJorge
                call resetGame
                call loadLevel

                pop iy
                pop ix
                pop de
                pop hl
                pop bc
                pop af

                ret

            notStairs:
            push iy             ;; metemos el tesoro en iy para destruirlo en la colision con markentity
            pop hl
            call getTreasure
            ld l,#2
            ld h,#15
            ld e,#65
            ld d,#0
            ld bc,#0
            ld a,#4
            call cpct_akp_SFXPlay_asm


        noTreasureCollidePlayer:

        ld a,#typeEnemy
        and e_type(iy)
        ld b, #typeEnemy
        sub b
        jr nz, noEnemyCollidePlayer

            ld b, e_dmg(iy)
            call damagePlayer
            
        noEnemyCollidePlayer:

        ld a,#typeHealing
        and e_type(iy)
        ld b, #typeHealing
        sub b
        jr nz, noHealingCollidePlayer
            push iy
            pop hl
            call healPlayer
            
        noHealingCollidePlayer:

        ld a,#typeShoot
        and e_type(iy)
        ld b, #typeShoot
        sub b
        jr nz, noShotCollidePlayer

        ld a,e_subType(iy)
        sub #0
        jr z,noShotCollidePlayer
            push iy
            pop hl
            ld b, e_dmg(iy)
            call damagePlayer
          

            push ix
            push iy
            pop ix
            call markShot
           
            pop ix
           
        noShotCollidePlayer:
     
     
ret 


collisionBehaviourShot::

        ld a,e_subType(ix)
        sub #0    
        jr  nz, noEnemyCollideShot
            ld a,#typeEnemy
            and e_type(iy)
            ld b, #typeEnemy
            sub b
            jr nz, noEnemyCollideShot
                ld a,#undying
                and e_subType(iy)
                ld b, #undying
                sub b
                jr z, noEnemyCollideShot

                    push ix
                    pop hl

                    push iy
                    pop de

                    push ix
                    push iy

                    call shotHit

                    pop iy
                    pop ix
        noEnemyCollideShot:
ret

collisionBehaviourEnemy::
        
        ld a,#typeShoot
        and e_type(iy)
        ld b, #typeShoot
        sub b
        jr nz, noShootCollideEnemy
            ld a,#undying
            and e_subType(ix)
            ld b, #undying
            sub b
            jr z, noShootCollideEnemy
                ld a,e_subType(iy)
                sub #0    
                jr  nz, noShootCollideEnemy

                    push iy             ;;aqui esta la bala
                    pop hl

                    push ix             ;;aqui esta el enemigo
                    pop de

                    push ix
                    push iy

                    call shotHit

                    pop iy
                    pop ix
                noShootCollideEnemy:



ret




