.include "../manager/entity.h.s"
.include "../manager/template.h.s"
.include "../manager/animation.h.s"
.include "../manager/game.h.s"
.include "cpctelera.h.s"
.include "physics.h.s"

.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm
.globl cpct_akp_SFXPlay_asm
.globl cpct_akp_musicPlay_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_stop_asm
.globl _sounds
.globl _songDemo


auxCheck:: .db 0

velocityPlayerX=1
velocityPlayerY=2

pressX:: .db 0
pressY:: .db 0
dirPlayerX:: .db 0
dirPlayerY:: .db 5
maxShots:: .db 5
contShot:: .db 0
coolDownShot:: .db coolDownShotInit



maxEnemyShots:: .db 8
contEnemyShot:: .db 0

.globl cpct_akp_musicInit_asm


toggleMute: .db 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,
;; Con esta funcion comprobamos que teclas se han pulsado
;;
;;  Input
;;  ix -> debe tener la posicion de memoria de la entidad a tratar
;;  destruye registros: HL, DE, BC, AF

detectKeyboard::
  ld a, #0
  ld (pressX), a
  ld (pressY), a


    ld hl, #Key_M    ;;MUTEAR
    call cpct_isKeyPressed_asm
    jr z, noPressM
     
     ld de, #_sounds         ;; Make DE point to music again, as previous call may have corrupted it
     call cpct_akp_musicInit_asm     ;; Initialize instruments and music for music play
     call cpct_akp_musicPlay_asm
     ld a,#1
     ld (toggleMute),a
     jr noPressM

    noPressM:

    ld a,(toggleMute)
    cp #0
    jr z,noPressN
      ld hl, #Key_N    ;;MUTEAR
      call cpct_isKeyPressed_asm
      jr z, noPressN
      
      ld de, #_songDemo      ;; Make DE point to music again, as previous call may have corrupted it
      call cpct_akp_musicInit_asm     ;; Initialize instruments and music for music play
      call cpct_akp_musicPlay_asm
      ld a,#0
      ld (toggleMute),a
      jr noPressN

    noPressN:



  
  
  ;;compruebo si se pulsa Espacio
  ld a,e_shootCounter(ix)
  add #0
  jr nz,coolDown

  ;###########################

  ld hl, #Joy0_Fire1
  call cpct_isKeyPressed_asm
  jr nz, spaceYes

  ld hl, #Joy0_Fire2
  call cpct_isKeyPressed_asm
  jr nz, spaceYes

  ;###########################

  ld hl, #Key_Space
  call cpct_isKeyPressed_asm
  jr z, noSpace
   
    ;;Ha pulsado el Espacio
    ld a, (contShot)
    ld b, a
    ld a, (maxShots)
    sub b
    jr z, noSpace   ;;maximo de disparos creados

  spaceYes:
    ld l,#1     
    ld h,#15
    ld e,#45
    ld d,#0
    ld bc,#0
    ld a,#4
    call cpct_akp_SFXPlay_asm

      
    ;;puede crear nuevo disparo
      ld hl,#shot
      call createEntity
      call setShot
    ;;actualizar contador
      ld a, (contShot)
      inc a
      ld (contShot), a

      ld a,(coolDownShot)    ;;reseteamos el enfriamiento del disparo
      ld e_shootCounter(ix),a

      jr noSpace

    coolDown:     ;;bajamos el cooldown
     dec a
     ld e_shootCounter(ix),a

    noSpace:

  ;;variables iniciales de velocidad en x
  ld e, #0

  ;;compruebo si se pulsa A

  ;###########################

  ld hl, #Joy0_Left
  call cpct_isKeyPressed_asm
  jr nz, yesPressA

  ;###########################

  ld hl, #Key_O
  call cpct_isKeyPressed_asm
  jr z, noPressA
    ;;Ha pulsado la O
  yesPressA:
    ld a, #-velocityShotX
    ld (pressX), a
    ld e, #-velocityPlayerX
    jr endHorizontal
  noPressA:

  ;;compruebo si se pulsa D

  ;###########################

  ld hl, #Joy0_Right
  call cpct_isKeyPressed_asm
  jr nz, yesPressD

  ;###########################

  ld hl, #Key_P
  call cpct_isKeyPressed_asm
  jr z, endHorizontal
    ;; ha pulsado P
  yesPressD:
    ld a, #velocityShotX
    ld (pressX), a
    ld e, #velocityPlayerX

  ;;aqui ya hemos acabado de comprobar las teclas horizontales A D, por eso cambio la velocidad
  endHorizontal:
  ld e_vx(ix), e

  ;;variables iniciales de velocidad en x
  ld e, #0
  ;;compruebo si se pulsa W

  ;###########################

  ld hl, #Joy0_Up
  call cpct_isKeyPressed_asm
  jr nz, yesPressW

  ;###########################

  ld hl, #Key_Q
  call cpct_isKeyPressed_asm
  jr z, noPressW
    ;;Ha pulsado la Q
  yesPressW:
    ld a, #-velocityShotY
    ld (pressY), a
    ld e, #-velocityPlayerY
    jr endVertical
  noPressW:

  ;;compruebo si se pulsa S

  ;###########################

  ld hl, #Joy0_Down
  call cpct_isKeyPressed_asm
  jr nz, yesPressS

  ;###########################

  ld hl, #Key_A
  call cpct_isKeyPressed_asm
  jr z, endVertical
    ;; ha pulsado A
  yesPressS:
    ld a, #velocityShotY
    ld (pressY), a
    ld e, #velocityPlayerY
  endVertical:
  ;;actualizamos velocidad en cada eje e -> x  d -> y
  ld e_vy(ix), e

 ;;Comprobar si se ha presionado alguna direccion
  ld a, (pressX)
  add #0
  jr z, noX

  ld (dirPlayerX), a  ;; if (pressX != 0) -> ha pulsado
  ld a, (pressY)
  ld (dirPlayerY), a 

  noX:
    ld a, (pressY)
    add #0
    jr z, endPress    ;; if (pressX == 0 && pressY == 0) -> no ha pulsado nada

    ld (dirPlayerY), a  ;; if (pressY != 0) -> ha pulsado
    ld a, (pressX)
    ld (dirPlayerX), a 

    ld ix, #_arrayEntities

  endPress:
    ld a, (pressX)
    add #0
    jr z, next

      ld a, e_component(ix)
      or #cmpAnim           ;; anadir componente
      ld e_component(ix), a

      call updatePlayerDir
      ret

  next:
    ld a, (pressY)
    add #0
    jr z, finish

      ld a, e_component(ix)
      or #cmpAnim           ;; anadir componente
      ld e_component(ix), a

      call updatePlayerDir
      ret

    finish:
      ld ix, #_arrayEntities

      ld a, e_dmg(ix)
      add #0
      ret nz


      ld hl, (spriteActual)
      ld e_sprite2(ix), l
      ld e_sprite1(ix), h

      ld a, #cmpAnim
      cpl
      ld b, a
      ld a, e_component(ix)
      and b                 ;; quitar componente
      ld e_component(ix), a

ret


spriteActual:: .dw _spPlayer_00
auxSprite:: .db 0

updatePlayerDir::
  ld a, #0
  ld (auxSprite), a

  ld ix, #_arrayEntities    ;; jugador

  ld a, (pressX)  ;; -3, 0 o 3
  add #0
  jr z, checkY   ;; no tiene X

  ; si tiene X
    ld b, a
    ld a, #velocityShotX  ;; 3
    add a, b              ;; = 0 -> izquierda
    jr z, playerLeft

      ld a, #1    ; derecha
      ld (auxSprite), a

      ld a, (pressY)
      add #0
      jp nz, checkY

      ld l,#<_spPlayer_24
      ld h,#>_spPlayer_24

      call checkSprite

      ld a, (auxCheck)
      add #0
      jp nz, checkY

        ld ix, #_arrayEntities

        ld a, e_dmg(ix)
        add #0
        jr nz, checkY

        ld e_sprite2(ix),#<_spPlayer_24
        ld e_sprite1(ix),#>_spPlayer_24

        ld e_animPointer2(ix), #<animPlayer7
        ld e_animPointer1(ix), #>animPlayer7
        ld e_animCounter(ix), #0x05

      jr checkY

    playerLeft:
      ld a, #2    ; izquierda
      ld (auxSprite), a

      ld a, (pressY)      ;; -5, 0 o 5
      add #0
      jp nz, checkY

      ld l,#<_spPlayer_08
      ld h,#>_spPlayer_08

      call checkSprite

      ld a, (auxCheck)
      add #0
      jp nz, checkY

        ld a, e_dmg(ix)
        add #0
        jr nz, checkY

        ld e_sprite2(ix),#<_spPlayer_08
        ld e_sprite1(ix),#>_spPlayer_08

        ld e_animPointer2(ix), #<animPlayer3
        ld e_animPointer1(ix), #>animPlayer3
        ld e_animCounter(ix), #0x05


  checkY:
    ld a, (pressY)      ;; -5, 0 o 5
    add #0
    jp z, endPlayerDir   ;; no tiene Y

    ; si tiene Y
      ld b, a
      ld a, #velocityShotY  ;; 5
      add a, b           ;; = 0 -> arriba
      jp z, playerUp

        ld a, (auxSprite)
        add #0
        jr z, down          ;; no horizontal

        dec a
        jr z, downRight      ;; derecha + abajo

      ; izquierda + abajo
          ld l,#<_spPlayer_04
          ld h,#>_spPlayer_04

          call checkSprite

          ld a, (auxCheck)
          add #0
          jp nz, endPlayerDir

            ld a, e_dmg(ix)
            add #0
            jp nz, endPlayerDir

          ld e_sprite2(ix),#<_spPlayer_04
          ld e_sprite1(ix),#>_spPlayer_04

          ld e_animPointer2(ix), #<animPlayer2
          ld e_animPointer1(ix), #>animPlayer2
          ld e_animCounter(ix), #0x05

          jp endPlayerDir


        downRight:
          ld l,#<_spPlayer_28
          ld h,#>_spPlayer_28

          call checkSprite

          ld a, (auxCheck)
          add #0
          jp nz, endPlayerDir

            ld a, e_dmg(ix)
            add #0
            jp nz, endPlayerDir

          ld e_sprite2(ix),#<_spPlayer_28
          ld e_sprite1(ix),#>_spPlayer_28

          ld e_animPointer2(ix), #<animPlayer8
          ld e_animPointer1(ix), #>animPlayer8
          ld e_animCounter(ix), #0x05

          jp endPlayerDir

        down:
          ld l,#<_spPlayer_00
          ld h,#>_spPlayer_00

          call checkSprite

          ld a, (auxCheck)
          add #0
          jp nz, endPlayerDir

            ld a, e_dmg(ix)
            add #0
            jp nz, endPlayerDir

          ld e_sprite2(ix),#<_spPlayer_00
          ld e_sprite1(ix),#>_spPlayer_00

          ld e_animPointer2(ix), #<animPlayer1
          ld e_animPointer1(ix), #>animPlayer1
          ld e_animCounter(ix), #0x05

          jp endPlayerDir

    playerUp:
      ld a, (auxSprite)
      add #0
      jr z, up          ;; no horizontal

      dec a
      jr z, upRight      ;; izquierda + arriba

    ; derecha + arriba
        ld l,#<_spPlayer_12
        ld h,#>_spPlayer_12

        call checkSprite

        ld a, (auxCheck)
        add #0
        jr nz, endPlayerDir

          ld a, e_dmg(ix)
          add #0
          jr nz, endPlayerDir

        ld e_sprite2(ix),#<_spPlayer_12
        ld e_sprite1(ix),#>_spPlayer_12

        ld e_animPointer2(ix), #<animPlayer4
        ld e_animPointer1(ix), #>animPlayer4
        ld e_animCounter(ix), #0x05

        jr endPlayerDir


      upRight:
        ld l,#<_spPlayer_20
        ld h,#>_spPlayer_20

        call checkSprite

        ld a, (auxCheck)
        add #0
        jr nz, endPlayerDir

          ld a, e_dmg(ix)
          add #0
          jr nz, endPlayerDir

        ld e_sprite2(ix),#<_spPlayer_20
        ld e_sprite1(ix),#>_spPlayer_20

        ld e_animPointer2(ix), #<animPlayer6
        ld e_animPointer1(ix), #>animPlayer6
        ld e_animCounter(ix), #0x05

        jr endPlayerDir

      up:
        ld l,#<_spPlayer_16
        ld h,#>_spPlayer_16

        call checkSprite

        ld a, (auxCheck)
        add #0
        jr nz, endPlayerDir

          ld a, e_dmg(ix)
          add #0
          jr nz, endPlayerDir

        ld e_sprite2(ix),#<_spPlayer_16
        ld e_sprite1(ix),#>_spPlayer_16

        ld e_animPointer2(ix), #<animPlayer5
        ld e_animPointer1(ix), #>animPlayer5
        ld e_animCounter(ix), #0x05

  endPlayerDir:

ret


checkSprite::
  push hl

  ld a, e_animPointer2(ix)
  sub #<animDamage
  jr nz, continueCheck

    ld a, e_animPointer1(ix)
    sub #>animDamage
    jr nz, continueCheck

      ld a, e_dmg(ix)
      add #0
      jr nz, continueCheck

        ld a, #0
        ld (auxCheck), a

        pop hl

    ret


  continueCheck:

    pop hl

  ld bc, (spriteActual)
  ld a, b
  sub h
  jr nz, change

    ld a, c
    sub l
    jr nz, change

      ld a, #1
      ld (auxCheck), a

      ret

  change:
    ld a, #0
    ld (auxCheck), a
    
    ld (spriteActual), hl

    push ix

    ld ix, #animDamage

    ld 1(ix), l
    ld 2(ix), h

    pop ix

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,
;; Con esta funcion actualizamos la fisica de cada entidad
;;
;;  Input
;;  ix -> debe tener la posicion de memoria de la entidad a tratar
;;  destruye registros: HL, DE, BC, AF
frameDetect=1
frameAux:.db 0
updatePhysicsEntity::

  ;; comprobamos si la entidad tiene componente input
  ld a, e_component(ix)
  and #cmpInput
  sub #cmpInput
  jr nz, noInput
    ;;si tiene componente input
    call detectKeyboard

  noInput:
                 
    ld a,e_x(ix)        ;;contenido de la posicion 0     X =10
    add a,e_vx(ix)             ;; sumamos espacio mas velocidad   10-11 = -1
    sub #paddingH    
    jp m,finSaleX
   
      ld a,e_x(ix)        
      add e_vx(ix) 
      add e_wi(ix)
      ld b,a
      ld a,#rightBorder     
      sub b
      sub #paddingH 
      jp m,finSaleX

        ld a,e_type(ix)
        and #typeEnemy
        sub #typeEnemy
        jr nz,noChaser
          ld a,e_subType(ix)
          and #chaser
          sub #chaser
          jr nz,noChaser

            ld a,e_shootCounter(ix)    ;e_shootCounter
            xor #frameDetect
            ld e_shootCounter(ix),a
            cp #0
        jr z,notThisFrame



        noChaser:
        ld a,e_x(ix)        ;;contenido de la posicion 0     X =10
        add a,e_vx(ix)             ;; sumamos espacio mas velocidad   10-11 = -1
        ld e_x(ix), a
        
        notThisFrame:
        jp comprobarVertical

    finSaleX:

    ld a,#typeShoot         ;; factorizar en una sola funcion
    and e_type(ix)
    ld b,#typeShoot
    sub b
    jr nz,noShootX
      call markShot
    noShootX:

    ld a,#typeEnemy         ;; factorizar en una sola funcion
    and e_type(ix)
    ld b,#typeEnemy
    sub b
    jr nz,noEnemyX
      ld a,e_vx(ix)
      neg
      ld e_vx(ix),a

    ;;cambio de animacion
      ld a, e_subType(ix)
      ld b, #0x08         ;; comprobar tipo lateral
      sub b
      jr nz, noEnemyX

        ld a, e_destroyCounter(ix)
        add #0
        jr z, changeAnimLatDer

            ld e_animPointer2(ix), #<animEnemyLateralIzq
            ld e_animPointer1(ix), #>animEnemyLateralIzq

            ld a, #0
            ld e_destroyCounter(ix), a

            jr noEnemyX

        changeAnimLatDer:
          ld e_animPointer2(ix), #<animEnemyLateralDer
          ld e_animPointer1(ix), #>animEnemyLateralDer

          ld a, #1
          ld e_destroyCounter(ix), a

    noEnemyX:

  
    comprobarVertical:
    ld a,e_y(ix)
    add a,e_vy(ix)             ;; sumamos espacio mas velocidad   10-11 = -1    
    ld b, #127  ;;MAGIC NUMBERS FEOS
    sub b
    jp p, comprobarDebajo
      comprobarArriba:
        ld a,e_y(ix)
        add a,e_vy(ix) 
        sub #paddingTop
        jp m,finSaleY
          ld a,e_y(ix)        ;;contenido de la posicion 0     X =10
          add a,e_vy(ix)             ;; sumamos espacio mas velocidad   10-11 = -1
          ld e_y(ix), a
          ret
      comprobarDebajo:
        add e_he(ix)
        ld b, #73  ;;MAGIC NUMBERS FEOS
        sub b
        add #paddingBottom
        jp p,finSaleY
          ld a,e_y(ix)        ;;contenido de la posicion 0     X =10
          add a,e_vy(ix)             ;; sumamos espacio mas velocidad   10-11 = -1
          ld e_y(ix), a  
          ret    
   finSaleY:
    ld a,#typeShoot      ;;factorizar
    and e_type(ix)
    ld b,#typeShoot
    sub b
    jr nz,noShootY
      call markShot
      noShootY:
    
    ld a,#typeEnemy         ;; factorizar en una sola funcion
    and e_type(ix)
    ld b,#typeEnemy
    sub b
    jr nz,noEnemyY
      ld a,e_vy(ix)
      neg
      ld e_vy(ix),a
    noEnemyY:
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,
;; Con esta funcion actualizamos la fisica de todas las entidades
;;  destruye registros: HL, DE, BC, AF
updatePhysics::
    ld de, #updatePhysicsEntity
  ld a,#cmpMovable
  call doBySignature
ret