.include "../manager/entity.h.s"


.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_drawSprite_asm
.globl _mySetDrawCharM0


;; PINTAR LA ENTIDAD
  ;; INPUT
  ;; IX - entidad a pintar
  ;; registros destruidos: DE, HL, AF, BC
renderEntity::  


  ;;primero comprobamos que se haya movido alguna vez para borrar su estela
  ld l , e_memPos2(ix)
  ld h, e_memPos1(ix)
  ld de, #0
  or a
  sbc hl, de
  jr z, notErase
    ex de, hl ;; memory	Video memory pointer to the upper left box corner byte
    ld a, #0x00  ;;colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
    ld c, e_wi(ix)  ;;width	Box width in bytes [1-64] (Beware!  not in pixels!)
    ld b, e_he(ix) ;;height	Box height in bytes (>0)
    call cpct_drawSolidBox_asm
  notErase:


  ld de, #0xC000      ;; inicio de la zona de memoria de video
  ld c, e_x(ix)       ;; x de la entidad
  ld b, e_y(ix)       ;; y de la entidad
  call cpct_getScreenPtr_asm    
  ;;se destruyen los registros AF, BC, DE. Devuelve el puntero en HL
  ex de, hl         ;; de -> ponemos la posicion destino donde copiar

  ;;nos guardamos la posicion pintamos el sprite en memoria (para la siguiente vez borrarlo)
  ld e_memPos2(ix), e
  ld e_memPos1(ix), d

  ld a,e_type(ix)  ;;tenemos el tipo
  and #typeDead    
  sub #typeDead
  jr nz,drawAlive      ;;comprobamos si esta muerta

   ;;; pintarMuerta
    ld a,#0x00
    ld c,e_wi(ix)
    ld b,e_he(ix)
    call cpct_drawSolidBox_asm
    jr endRenderEntity
    
  drawAlive: ;si la entidad esta viva

    ld c, e_wi(ix)                  ;; tenemos el w de la imagen                     ;;4003
    ld b, e_he(ix)                  ;; tenemos el h de la imagen

    ld l, e_sprite2(ix)
    ld h, e_sprite1(ix)
    
    call cpct_drawSprite_asm
    ;; Registros destruidos AF, BC, DE, HL
    endRenderEntity:
    
  ret

renderEntities::
  ld de, #renderEntity
  ld a,#cmpRender
  call doBySignature
ret

colorCounter= #0x05
counterColor:: .db 0x00
showLooseHP::
       ld hl, #0x0204
       call _mySetDrawCharM0        
       ld a,#colorCounter
       ld (counterColor),a
ret

showGainHP::
      ld hl, #0x0205
      call _mySetDrawCharM0
      ld a,#colorCounter
      ld (counterColor),a
ret